/*
 ============================================================================
 Name        : fork.c
 Author      : nome
 Version     :
 Copyright   : sistemi operativi
 Description : Hello World in C, Ansi-style
 ============================================================================
 */

#include <stdio.h>
#include <stdlib.h>
#include <sys/types.h>
#include <unistd.h>

int main(int argc, char **argv) {
	pid_t pid;
	int  i;
	int status = 99;

	if (argc < 2) {
		fprintf(stderr, "Errore nei parametri\n");
		fprintf(stderr, "Usage: %s path1 [path2 ...]\n", argv[0]);
		exit(-1);
	}

	pid = fork();

	if (pid < 0)
	{
		fprintf(stderr, "generazione nuovo processo fallita\n");
		exit(-1);
	}
	else if (pid == 0) { 	/* processo figlio */
		printf("Processo figlio (Parent PID=%d, PID=%d)\n",
				getppid(), getpid());
		argv[0] = "ls";
		execvp("/bin/ls", argv);
	}

	printf("Processo padre (Parent PID=%d, PID=%d) in attesa della terminazione del figlio\n",
			getppid(), getpid());
	wait(&status);
	printf("Esecuzione terminata (pid=%d)\n", pid);
	status = status >> 8;
	printf("status = %d\n", status);
	exit(status);
}
